Attribute VB_Name = "Config"
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Sub AscDump()
Dim x As Integer
For x = 1 To 255: Debug.Print Chr$(x); x: Next x
End Sub

Public Function KeyStr(KeyCode As Integer) As String
    'Copyright Alexander Chia Yan Sheng

    Select Case KeyCode
        Case 65 To 90
        KeyStr = Chr(KeyCode)
        Case 48 To 57
        KeyStr = Chr(KeyCode)
        Case 13
        KeyStr = "Enter"
        Case 9
        KeyStr = "Tab"
        Case 112 To 123
        KeyStr = "F" & LTrim(Str(KeyCode - 111))
        Case 27
        KeyStr = "Esc"
        Case 192
        KeyStr = "~"
        Case 187
        KeyStr = "="
        Case 189
        KeyStr = "-"
        Case 219
        KeyStr = "["
        Case 220
        KeyStr = "\"
        Case 221
        KeyStr = "]"
        Case 186
        KeyStr = ";"
        Case 222
        KeyStr = "'"
        Case 188
        KeyStr = ","
        Case 190
        KeyStr = "."
        Case 191
        KeyStr = "/"
        Case 16
        KeyStr = "Shift"
        Case 20
        KeyStr = "Caps Lock"
        Case 144
        KeyStr = "Num Lock"
        Case 145
        KeyStr = "Scr Lock"
        Case 17
        KeyStr = "Ctrl"
        Case 18
        KeyStr = "Alt"
        Case 32
        KeyStr = "Space"
        Case 45
        KeyStr = "Ins"
        Case 46
        KeyStr = "Del"
        Case 33
        KeyStr = "Pg Up"
        Case 34
        KeyStr = "Pg Dn"
        Case 8
        KeyStr = "Back"
        Case 36
        KeyStr = "Home"
        Case 35
        KeyStr = "End"
        Case 37
        KeyStr = "Left Arrow"
        Case 38
        KeyStr = "Up Arrow"
        Case 39
        KeyStr = "Right Arrow"
        Case 40
        KeyStr = "Down Arrow"
        Case 106
        KeyStr = "* [Num Pad]"
        Case 107
        KeyStr = "+ [Num Pad]"
        Case 111
        KeyStr = "/ [Num Pad]"
        Case 109
        KeyStr = "- [Num Pad]"
        Case Else
        KeyStr = "!"
    End Select
End Function

Function WriteINI(sSection As String, sKeyName As String, sNewString As String) As Integer
    Dim r
    Dim sFilename As String
    sFilename = App.Path & "\BasicNES.cfg"
    r = WritePrivateProfileString(sSection, sKeyName, sNewString, sFilename)
End Function

Function ReadINI(Section, KeyName As String) As String
    Dim sRet As String
    Dim Filename As String
    Filename = App.Path & "\BasicNES.cfg"
    sRet = String(255, Chr(0))
    ReadINI = Left(sRet, GetPrivateProfileString(Section, ByVal KeyName, "", sRet, Len(sRet), Filename))
End Function

